import e32
import appuifw
import audio
import random
from graphics import *
from key_codes import *

class Keyboard(object):
    def __init__(self,onevent=lambda:None):
        self._keyboard_state={}
        self._downs={}
        self._onevent=onevent
    def handle_event(self,event):
        if event['type'] == appuifw.EEventKeyDown:
            code=event['scancode']
            if not self.is_down(code):
                self._downs[code]=self._downs.get(code,0)+1
            self._keyboard_state[code]=1
        elif event['type'] == appuifw.EEventKeyUp:
            self._keyboard_state[event['scancode']]=0
        self._onevent()
    def is_down(self,scancode):
        return self._keyboard_state.get(scancode,0)
    def pressed(self,scancode):
        if self._downs.get(scancode,0):
            self._downs[scancode]-=1
            return True
        return False
keyboard=Keyboard()


linrunning=0 #琳动拼图
numrunning=0 #数图狂拼

picroot="e:\\system\\apps\\LinJigsaw\\pic\\" #图片路径
configfile="e:\\system\\apps\\LinJigsaw\\config" #配置文件

file=open(configfile,'r')  
settingsfile = file.read()
settings = settingsfile.split(" ");
file.close()

delay=e32.Ao_timer()

soundroot="e:\\system\\apps\\LinJigsaw\\sound\\" #声音路径
def sound_start(): 
    filename=soundroot+"start.mp3"
    voice=audio.Sound.open(filename)
    voice.play()
    while voice.state()==audio.EPlaying:
        delay.after(0.01)
    voice.stop()
    voice.close()
    
def sound_linmove():      
    filename=soundroot+"linmove.mp3"
    voice=audio.Sound.open(filename)
    voice.play()
    while voice.state()==audio.EPlaying:
        delay.after(0.01)
    voice.stop()
    voice.close()

def sound_nummove():
    filename=soundroot+"nummove.mp3"
    voice=audio.Sound.open(filename)
    voice.play()
    while voice.state()==audio.EPlaying:
        delay.after(0.01)
    voice.stop()
    voice.close()
    
def sound_conf():
    filename=soundroot+"conf.mp3"
    voice=audio.Sound.open(filename)
    voice.play()
    while voice.state()==audio.EPlaying:
        delay.after(0.01)
    voice.stop()
    voice.close()
    
def sound_win():
    filename=soundroot+"win.mp3"
    voice=audio.Sound.open(filename)
    voice.play()
    while voice.state()==audio.EPlaying:
        delay.after(0.01)
    voice.stop()
    voice.close()


def exit():  #退出
    global linrunning,numrunning
    if appuifw.query('确认退出游戏'.decode('utf8'),'query'):
        linrunning=0
        numrunning=0
        appuifw.app.set_exit()
    else:
        background()  
def cancel(): #返回
    global linrunning,numrunning
    linrunning=0
    numrunning=0
    background()
    
def background():
    appuifw.app.screen='full'
    appuifw.app.exit_key_handler=exit

    canvas=appuifw.Canvas(event_callback=None, redraw_callback=None)
    appuifw.app.body=canvas
    filename=picroot+"main.png"
    backpic=Image.open(filename)
    canvas.blit(backpic)
    
    appuifw.app.menu =[('新建游戏'.decode("utf-8"),startgame),
    
                     (('设置模式'.decode("utf-8")),
                       (('琳动拼图'.decode("utf-8"),modeset1),
                       ('数图狂拼'.decode("utf-8"),modeset2))),
                         
                    (('设置音效'.decode("utf-8")),
                      (('开启音效'.decode("utf-8"),soundseton),
                      ('关闭音效'.decode("utf-8"),soundsetoff))),
                       
                     (('帮助信息'.decode("utf-8")),
                       (('操作说明'.decode("utf-8"),helpinfo),
                        ('关于信息'.decode("utf-8"),aboutinfo))),
                       
                       ('退出游戏'.decode("utf-8"),exit)]                       
def aboutinfo():
    appuifw.app.exit_key_handler=cancel   
    canvas=appuifw.Canvas(event_callback=None, redraw_callback=None)
    appuifw.app.body=canvas
    filename=picroot+"bar1.png"
    pic=Image.open(filename)
    canvas.blit(pic,target=(0,182))
    filename=picroot+"bar2.png"
    pic=Image.open(filename)
    canvas.blit(pic,target=(150,182))    
    canvas.text((55,30),"杜俊作品".decode("utf-8"),0xff0232,'title')
    canvas.text((10,50),"谨贺".decode("utf-8"),0xff0232,'title')
    canvas.text((46,50),"邵晓琳".decode("utf-8"),0xab1f7e,'title')
    canvas.text((100,50),"22岁芳诞".decode("utf-8"),0xff0232,'title')
    canvas.text((5,70),"(1985年10月15日上午五时)".decode("utf-8"),0xff0232,'title')    
    canvas.text((5,135),"shagon presents".decode("utf-8"),0x000000,'dense')
    canvas.text((5,150),"www.cnpda.com.cn".decode("utf-8"),0x000000,'dense')
    canvas.text((5,165),"编程组".decode("utf-8"),0x000000,'dense')
    canvas.text((5,180),"2007.10.15".decode("utf-8"),0x000000,'dense')       
def helpinfo():
    appuifw.app.exit_key_handler=cancel   
    canvas=appuifw.Canvas(event_callback=None, redraw_callback=None)
    appuifw.app.body=canvas
    filename=picroot+"bar1.png"
    pic=Image.open(filename)
    canvas.blit(pic,target=(0,182))
    filename=picroot+"bar2.png"
    pic=Image.open(filename)
    canvas.blit(pic,target=(150,182))    
    canvas.text((5,20),"琳动拼图:".decode("utf-8"),0xff0232,'title')  
    canvas.text((25,35),"常规玩法，比较简单。".decode("utf-8"),0x000000,'dense')
    canvas.text((25,50),"用导航键或2/8/4/6移动方块，".decode("utf-8"),0x000000,'dense')
    canvas.text((2,65),"拼成完整图片。".decode("utf-8"),0x000000,'dense')    
    canvas.text((5,90),"数图狂拼:".decode("utf-8"),0xff0232,'title')  
    canvas.text((25,105),"创新玩法，难度极大。".decode("utf-8"),0x000000,'dense')
    canvas.text((25,120),"用导航键或2/8/4/6控制方向，".decode("utf-8"),0x000000,'dense')
    canvas.text((2,135),"心算移动后的位置，达到一定连".decode("utf-8"),0x000000,'dense')
    canvas.text((2,150),"击后按导航中键或数字键5确定。".decode("utf-8"),0x000000,'dense')
    canvas.text((25,165),"此模式已锁定，必须先通过".decode("utf-8"),0x000000,'dense')
    canvas.text((2,180),"琳动拼图。".decode("utf-8"),0x000000,'dense')     
def modeset1():    
    settings[2]="linmode"
    file=open(configfile,'w')  
    file.write(settings[0]+" "+settings[1]+" "+settings[2])    
    file.close()    
    appuifw.note("已设置为\n“琳动拼图”".decode("utf-8"),"conf")
    background()
def modeset2():     
    if settings[0]<>"shagon201314":
        appuifw.note("琳动拼图还没过关呢！设置失败".decode("utf-8"),"error")
    else:
        settings[2]="nummode"
        file=open(configfile,'w') 
        file.write(settings[0]+" "+settings[1]+" "+settings[2]) 
        file.close()
        appuifw.note("已设置为\n“数图狂拼”".decode("utf-8"),"conf")
    background()
def soundseton():
    settings[1]="soundon"
    file=open(configfile,'w')  
    file.write(settings[0]+" "+settings[1]+" "+settings[2])  
    file.close()    
    appuifw.note("已开启音效".decode("utf-8"),"conf")
    background()
def soundsetoff():
    settings[1]="soundoff"
    file=open(configfile,'w')  
    file.write(settings[0]+" "+settings[1]+" "+settings[2]) 
    file.close()    
    appuifw.note("已关闭音效".decode("utf-8"),"conf")
    background()
def startgame():
    global linrunning,numrunning
    linrunning=0
    numrunning=0
    if settings[2]=="linmode": shaoxiaolin()
    else: numbermove()
def shaoxiaolin():
    global linrunning
    linrunning=1
    appuifw.app.exit_key_handler=cancel
    canvas=appuifw.Canvas(event_callback=keyboard.handle_event, redraw_callback=None)
    appuifw.app.body=canvas
    filename=picroot+"linback.png"
    backpic=Image.open(filename)
    canvas.blit(backpic)
    canvas.text((45,90),"正在初始化...".decode("utf-8"),0xff0232,'title')
    if settings[1]=="soundon":
        sound_start()  
    movecount=0
    
    #初始化拼盘
   
    block=[0 for x in range(14)]
    block[1]=random.randint(1,12)
    for i in range(2,13):
        while 1:            
            temp=random.randint(1,12)
            re=0
            for j in range(1,i):
                if temp==block[j]:
                    re=1
                    break
            if re==0:
                block[i]=temp
                break
    temp=block[10]
    for i in range(1,13):
        if block[i]==10:
            block[i]=temp
    block[10]=10
    
    athwart=0
    for m in range(1,12):
        for n in range(m+1,13):
            if block[m]>block[n]:
                athwart=athwart+1
    if athwart%2==1:
        swap=block[1]
        block[1]=block[2]
        block[2]=swap
        
    filename=picroot+"scoreback.png"
    scorebackpic=Image.open(filename)    

    blockpic=[]
    filename=picroot+"linempty.png"
    pic=Image.open(filename)
    blockpic.append(pic)
    
    for i in range(1,13):
        filename=picroot+"lin"+str(i)+".png"
        pic=Image.open(filename)
        blockpic.append(pic)
        
    pox=[0,31,69,107,31,69,107,31,69,107,31,69,107,31]
    poy=[0,9,9,9,47,47,47,85,85,85,123,123,123,161]
      
    for i in range(1,14):        
        canvas.blit(blockpic[block[i]],target=(pox[i],poy[i]))    
    canvas.text((80,200),"%s".decode("utf-8")%movecount,0xff0232,'title')
    emptypos=13
    
    while linrunning:
        if keyboard.pressed(EScancode2) or keyboard.pressed(EScancodeUpArrow):
            if emptypos not in [11,12,13]:
                temp=block[emptypos]
                block[emptypos]=block[emptypos+3]
                emptypos+=3 
                block[emptypos]=temp                               
                canvas.blit(blockpic[block[emptypos]],target=(pox[emptypos],poy[emptypos]))
                canvas.blit(blockpic[block[emptypos-3]],target=(pox[emptypos-3],poy[emptypos-3])) 
                if settings[1]=="soundon":
                    sound_linmove()                
                movecount+=1
        if keyboard.pressed(EScancode8) or keyboard.pressed(EScancodeDownArrow):
            if emptypos not in [1,2,3]:
                temp=block[emptypos]
                block[emptypos]=block[emptypos-3]
                emptypos-=3  
                block[emptypos]=temp                              
                canvas.blit(blockpic[block[emptypos]],target=(pox[emptypos],poy[emptypos]))
                canvas.blit(blockpic[block[emptypos+3]],target=(pox[emptypos+3],poy[emptypos+3])) 
                if settings[1]=="soundon":
                    sound_linmove()
                movecount+=1                
        if keyboard.pressed(EScancode4) or keyboard.pressed(EScancodeLeftArrow):
            if emptypos not in [3,6,9,12]:
                temp=block[emptypos]
                block[emptypos]=block[emptypos+1]
                emptypos+=1
                block[emptypos]=temp 
                canvas.blit(blockpic[block[emptypos]],target=(pox[emptypos],poy[emptypos]))
                canvas.blit(blockpic[block[emptypos-1]],target=(pox[emptypos-1],poy[emptypos-1]))
                if settings[1]=="soundon":
                    sound_linmove()
                movecount+=1
        if keyboard.pressed(EScancode6) or keyboard.pressed(EScancodeRightArrow):
            if emptypos not in [1,4,7,10,13]:
                temp=block[emptypos]
                block[emptypos]=block[emptypos-1]
                emptypos-=1
                block[emptypos]=temp                                
                canvas.blit(blockpic[block[emptypos]],target=(pox[emptypos],poy[emptypos]))
                canvas.blit(blockpic[block[emptypos+1]],target=(pox[emptypos+1],poy[emptypos+1]))
                if settings[1]=="soundon":
                    sound_linmove()
                movecount+=1
        canvas.blit(scorebackpic,target=(71,183))
        canvas.text((80,200),"%s".decode("utf-8")%movecount,0xff0232,'title')
        
        done=1
        for i in range(1,13):
            if block[i]<>i:
                done=0
                break
        if done==1:
            linrunning=0
            filename=picroot+"linphoto.png"
            winpic=Image.open(filename)
            canvas.blit(winpic)
            if settings[1]=="soundon":
                sound_win()
            delay.after(1)
            filename=picroot+"bar1.png"
            pic=Image.open(filename)
            canvas.blit(pic,target=(0,182))
            filename=picroot+"bar2.png"
            pic=Image.open(filename)
            canvas.blit(pic,target=(150,182)) 
            canvas.text((55,130),"恭喜过关".decode("utf-8"),0xff0232,'title')  
            if settings[0]=="locked":
                settings[0]="shagon201314"
                file=open(configfile,'w')
                file.write(settings[0]+" "+settings[1]+" "+settings[2])
                file.close()
                canvas.text((15,170),"数图狂拼模式已解锁".decode("utf-8"),0x0000ff,'title')                    
        e32.ao_yield()
        

def numbermove():
    global numrunning
    numrunning=1
    appuifw.app.exit_key_handler=cancel
    canvas=appuifw.Canvas(event_callback=keyboard.handle_event, redraw_callback=None)
    appuifw.app.body=canvas
    filename=picroot+"numback.png"
    backpic=Image.open(filename)
    canvas.blit(backpic)
    canvas.text((45,90),"正在初始化...".decode("utf-8"),0xff0232,'title')
    if settings[1]=="soundon":
        sound_start()  
    movecount=0
    maxcombo=0
    
    #初始化拼盘
    
    filename=picroot+"nummask.png"
    nummaskpic=Image.open(filename)
   
    block=[0 for x in range(17)]            
    block[1]=random.randint(1,15)
    for i in range(2,16):        
        while 1:
            re=0
            temp=random.randint(1,15)
            for j in range(1,i):
                if temp==block[j]:
                    re=1
                    break
            if re==0:
                block[i]=temp
                break                
    block[16]=16
    athwart=0
    for m in range(1,15):
        for n in range(m+1,16):
            if block[m]>block[n]:
                athwart=athwart+1
    if athwart%2==1:
        swap=block[1]
        block[1]=block[2]
        block[2]=swap
        
    blockpic=[]
    blockpic.append(backpic)    
    for i in range(1,16):
        filename=picroot+"num"+str(i)+".png"
        pic=Image.open(filename)
        blockpic.append(pic)
        
    filename=picroot+"numblack.png"
    pic=Image.open(filename)
    blockpic.append(pic)  
        
    pox=[0,20,54,88,122,20,54,88,122,20,54,88,122,20,54,88,122]
    poy=[0,14,14,14,14,48,48,48,48,82,82,82,82,116,116,116,116]   
    pox1=[0,
         36,62,80,106,
         36,62,80,106,
         36,62,80,106,
         36,62,80,106
         ]    
    poy1=[0,
         30,30,30,30,
         56,56,56,56,
         74,74,74,74,
         100,100,100,100
         ]
    
    pox2=[0,
         52,70,72,90,
         52,70,72,90,
         52,70,72,90,
         52,70,72,90
         ]
    
    poy2=[0,
         46,46,46,46,
         64,64,64,64,
         66,66,66,66,
         84,84,84,84
         ]
    

    for i in range(1,16):
        canvas.blit(blockpic[block[i]],target=(pox[i],poy[i]))
    canvas.text((102,185),"%s".decode("utf-8")%movecount,0xff0232,'title')
    canvas.text((102,205),"%s".decode("utf-8")%maxcombo,0xff0232,'title')
    
    emptypos=16
    movecommand=[]
    temppos=emptypos
    while numrunning:
        if keyboard.pressed(EScancode2) or keyboard.pressed(EScancodeUpArrow):
            if temppos not in [13,14,15,16]:
                movecommand.append(2)                
                temppos+=4
                canvas.blit(nummaskpic,target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundoff": delay.after(0.2)
                canvas.blit(blockpic[block[temppos]],target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundon": sound_nummove()                
        if keyboard.pressed(EScancode8) or keyboard.pressed(EScancodeDownArrow):
            if temppos not in [1,2,3,4]:
                movecommand.append(8)                
                temppos-=4
                canvas.blit(nummaskpic,target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundoff": delay.after(0.2)
                canvas.blit(blockpic[block[temppos]],target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundon": sound_nummove()
        if keyboard.pressed(EScancode4) or keyboard.pressed(EScancodeLeftArrow):
            if temppos not in [4,8,12,16]:
                movecommand.append(4)                
                temppos+=1
                canvas.blit(nummaskpic,target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundoff": delay.after(0.2)
                canvas.blit(blockpic[block[temppos]],target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundon": sound_nummove()
        if keyboard.pressed(EScancode6) or keyboard.pressed(EScancodeRightArrow):
            if temppos not in [1,5,9,13]:
                movecommand.append(6)                
                temppos-=1
                canvas.blit(nummaskpic,target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundoff": delay.after(0.2)
                canvas.blit(blockpic[block[temppos]],target=(pox[temppos],poy[temppos]))
                if settings[1]=="soundon": sound_nummove()
        if keyboard.pressed(EScancode5) or keyboard.pressed(EScancodeSelect):
            tempcount=0
            
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(pox1[i],poy1[i]))
                
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(pox2[i],poy2[i]))                
                
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(71,65))
            
            for moving in movecommand:                
                if moving==2:
                    if emptypos not in [13,14,15,16]:
                        tempcount+=1
                        block[emptypos]=block[emptypos+4]
                        emptypos+=4
                        block[emptypos]=16                                                                    
                elif moving==8:
                    if emptypos not in [1,2,3,4]:
                        tempcount+=1
                        block[emptypos]=block[emptypos-4]
                        emptypos-=4
                        block[emptypos]=16                           
                elif moving==4:
                    if emptypos not in [4,8,12,16]:
                        tempcount+=1
                        block[emptypos]=block[emptypos+1]
                        emptypos+=1
                        block[emptypos]=16                         
                elif moving==6:
                    if emptypos not in [1,5,9,13]:
                        tempcount+=1
                        block[emptypos]=block[emptypos-1]
                        emptypos-=1
                        block[emptypos]=16                         
            if tempcount>maxcombo: maxcombo=tempcount
            movecount+=tempcount
            temppos=emptypos
            if settings[1]=="soundon":sound_conf()
            else: delay.after(0.5)
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(pox2[i],poy2[i]))
                
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(pox1[i],poy1[i]))
                
            canvas.blit(backpic)
            for i in range(1,17):
                canvas.blit(blockpic[block[i]],target=(pox[i],poy[i]))
                
            canvas.text((102,185),"%s".decode("utf-8")%movecount,0xff0232,'title')
            canvas.text((102,205),"%s".decode("utf-8")%maxcombo,0xff0232,'title')
            movecommand=[]
            
            done=1
            for i in range(1,16):
                if block[i]<>i:
                    done=0
                    break
            if done==1:
                numrunning=0
                filename=picroot+"linphoto.png"
                winpic=Image.open(filename)
                canvas.blit(winpic)
                if settings[1]=="soundon":
                    sound_win()
                delay.after(1)
                filename=picroot+"bar1.png"
                pic=Image.open(filename)
                canvas.blit(pic,target=(0,182))
                filename=picroot+"bar2.png"
                pic=Image.open(filename)
                canvas.blit(pic,target=(150,182))
                canvas.text((55,130),"恭喜过关".decode("utf-8"),0xff0232,'title')            
        e32.ao_yield()
        

def linjigsawrun():
    background()
    if settings[1]=="soundon":
        sound_start()
    
app_lock=e32.Ao_lock()
linjigsawrun()
app_lock.wait()